//---------------------------------------------------------------------------
//      Kurs OpenGL
//      Dobieslaw Paleczka
//      Cwiczenie 9
//---------------------------------------------------------------------------

#pragma hdrstop

#include "Gl\glut.h"

GLfloat ax=0,ay=0,az=0;
GLint w,h;

GLint lista;

void wyswietlaj(void)
{
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

        glColorMaterial(GL_FRONT, GL_DIFFUSE);
        glEnable(GL_COLOR_MATERIAL);

        //Lewe

        glViewport(0,0,w/2,h);

        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
        gluLookAt(5,5,5,0,0,0,0,1,0);
        glRotatef(ax,1,0,0);
        glRotatef(ay,0,1,0);
        glRotatef(az,0,0,1);

        glCallList(lista);

        //Prawe

        glViewport(w/2,0,w/2,h);

        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
        gluLookAt(-5,-5,-5,0,0,0,0,1,0);

        glRotatef(ax,1,0,0);
        glRotatef(ay,0,1,0);
        glRotatef(az,0,0,1);

        glCallList(lista);

        glutSwapBuffers();
}

void zmiana_rozmiaru(GLint ww, GLint hh)
{
        w=ww; h=hh;
        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        gluPerspective(55,float(w)/(float(h)*2.0),1,20);

}

void klawiatura(unsigned char c, int x, int y)
{
        const float s=5;
        if (c=='a') {ax+=s;}
        if (c=='z') {ax-=s;}
        if (c=='s') {ay+=s;}
        if (c=='x') {ay-=s;}
        if (c=='d') {az+=s;}
        if (c=='c') {az-=s;}
        glutPostRedisplay();
}

void animacja()
{
        ax+=0.1;
        glutPostRedisplay();
}

#pragma argsused
int main(int argc, char* argv[])
{
        glutInit(&argc, argv);
        glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
        glutInitWindowSize(450,450);
        glutInitWindowPosition(0,0);
        glutCreateWindow(argv[0]);


        glEnable(GL_DEPTH_TEST);

        GLfloat position1[] = {5.0, 5.5, 5.0, 0.0} ;
        GLfloat diffuse1[] = {1.0, 0.0, 0.0, 1.0} ;
        glLightfv(GL_LIGHT1, GL_POSITION, position1);
        glLightfv(GL_LIGHT1, GL_DIFFUSE, diffuse1);

        GLfloat position2[] = {-5.0, 5.5, 5.0, 0.0} ;
        GLfloat diffuse2[] = {0.0, 0.0, 1.0, 1.0} ;
        glLightfv(GL_LIGHT2, GL_POSITION, position2);
        glLightfv(GL_LIGHT2, GL_DIFFUSE, diffuse2);

        glEnable(GL_LIGHTING);
        glEnable(GL_LIGHT0);
        glEnable(GL_LIGHT1);
        glEnable(GL_LIGHT2);

        glShadeModel(GL_SMOOTH);

        glClearColor(0,0,0,0);

        glutDisplayFunc(wyswietlaj);
        glutReshapeFunc(zmiana_rozmiaru);
        glutKeyboardFunc(klawiatura);
        glutIdleFunc(animacja);

        lista = glGenLists(1);

        glNewList(lista, GL_COMPILE);

         glColor3f(1,0.9,0.9);
         glutSolidCube(2);

         glPushMatrix();
         glTranslatef(1,0,0);
         glColor3f(0,0.5,1);
         glutSolidCube(0.5);
         glPopMatrix();

         glPushMatrix();
         glTranslatef(0,1,0);
         glColor3f(0,1,0);
         glutSolidCube(0.5);
         glPopMatrix();

         glPushMatrix();
         glTranslatef(0,0,1);
         glColor3f(1,0,0);
         glutSolidSphere(0.5,8,8);
         glPopMatrix();

        glEndList();


        glutMainLoop();

        return 0;
}
//---------------------------------------------------------------------------
